package tr.edu.javaclassranking;

public class Edge {

	private short weight;
	private short A;
	private short B;
	private boolean owner;	//true means return, false means parameter. A->B
	
	public Edge(short weight, short a, short b, boolean owner) {
		this.weight = weight;
		A = a;
		B = b;
		this.owner = owner;
	}
	
	public short getWeight() {
		return weight;
	}

	public void setWeight(short weight) {
		this.weight = weight;
	}

	@Override
	public String toString() {
		return "Edge [weight=" + weight + ", A=" + A + ", B=" + B + ", owner="
				+ owner + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + A;
		result = prime * result + B;
		result = prime * result + (owner ? 1231 : 1237);
		result = prime * result + weight;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Edge other = (Edge) obj;
		if (A != other.A)
			return false;
		if (B != other.B)
			return false;
		if (owner != other.owner)
			return false;
		if (weight != other.weight)
			return false;
		return true;
	}
	
}