package tr.edu.javaclassranking.analyzers;

import java.io.FileNotFoundException;
import java.util.Locale;

import org.apache.commons.collections15.Transformer;

import tr.edu.javaclassranking.Edge;
import tr.edu.javaclassranking.Vertex;
import edu.uci.ics.jung.algorithms.scoring.BetweennessCentrality;
import edu.uci.ics.jung.graph.Graph;

public class BCAnalyze implements Analyzer {

	BetweennessCentrality<Vertex, Edge> bc = null;
	Graph<Vertex, Edge> g = null;
	String target;

	public BCAnalyze(Graph<Vertex, Edge> g, Transformer<Edge, ? extends Number> t, String target) {
		this.g = g;
		bc = new BetweennessCentrality<Vertex, Edge>(g, t);
		this.target = target;
	}

	public void printScreen() {
		for ( Vertex element : g.getVertices() )
			System.out.println(bc.getVertexScore(element));
	}

	@Override
	public void printFile(String fileName) {
		try {
			PWriter pw = new PWriter(fileName);
			GetInformation gi = new GetInformation(target);
			for ( Vertex element : g.getVertices() ) {
				pw.printf(new Locale("en"), PWriter.FORMAT, gi.getPackageAndClassName(element.getVertexId(), target), bc.getVertexScore(element));
			}
			gi.disconnect();
			pw.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}		
}
