package tr.edu.javaclassranking.analyzers;

import java.io.FileNotFoundException;
import java.util.Locale;

import org.apache.commons.collections15.Transformer;

import tr.edu.javaclassranking.Edge;
import tr.edu.javaclassranking.Vertex;
import edu.uci.ics.jung.algorithms.scoring.ClosenessCentrality;
import edu.uci.ics.jung.graph.Graph;

public class CCAnalyze implements Analyzer {

	ClosenessCentrality<Vertex, Edge> bc = null;
	Graph<Vertex, Edge> g = null;
	String target;
	Transformer<Edge, ? extends Number> t = null;

	public CCAnalyze(Graph<Vertex, Edge> g, Transformer<Edge, ? extends Number> t, String target) {
		this.g = g;
		bc = new ClosenessCentrality<Vertex, Edge>(g, t);
		this.target = target;
		this.t = t;
	}

	public void printScreen() {
		for ( Vertex element : g.getVertices() )
			System.out.println(bc.getVertexScore(element));
	}

	@Override
	public void printFile(String fileName) {
		try {
			PWriter pw = new PWriter(fileName);
			GetInformation gi = new GetInformation(target);
			String packageAndClassName = "";
			int counter = 0;
			for ( Vertex element : g.getVertices() ) {
				counter++;
				if ( counter % 100 == 0 ) {
					bc = null;
					System.gc();
					bc = new ClosenessCentrality<Vertex, Edge>(g, t);
				}
				packageAndClassName = gi.getPackageAndClassName(element.getVertexId(), target);
				pw.printf(new Locale("en"), PWriter.FORMAT, packageAndClassName, bc.getVertexScore(element));
			}
			gi.disconnect();
			pw.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}		
}
