package tr.edu.javaclassranking.analyzers;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class GetInformation {

	private Connection conn = null;
	private PreparedStatement prep = null;
	private ResultSet rs = null;

	// must be disconnected after the work is done.
	public GetInformation(String dbName) {
		dbName += ".db";
		try {
			Class.forName("org.sqlite.JDBC");
			conn = DriverManager.getConnection("jdbc:sqlite:" + dbName);
			prep = conn.prepareStatement("select name, package from unit where id = ?");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void disconnect() {
		try {
			conn.close();
			prep.close();
			if ( rs != null ) rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	public String getPackageAndClassName(int id, String dbName) {

		String toBeReturn = "not exist in the database";
		String name = null;
		String packageName = null;
		try {

			prep.setInt(1, id);
			rs = prep.executeQuery();

			if ( rs.next() ) {	// else not exist in the database.
				name = rs.getString("name");
				packageName = rs.getString("package");
				name = name.substring(packageName.length()+1);
				toBeReturn = rs.getString("package") + ", " + name;
			}
		} catch (SQLException e) {
			e.printStackTrace();
			return "some problems";
		}
		return toBeReturn;

	}

}
